package driver_system;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.net.URL;

import com.xuggle.mediatool.IMediaReader;
import com.xuggle.mediatool.IMediaViewer;
import com.xuggle.mediatool.MediaToolAdapter;
import com.xuggle.mediatool.ToolFactory;
import com.xuggle.mediatool.event.IVideoPictureEvent;

/******************************************************************************/


public class DecodeAndPlayVideoXuggle extends MediaToolAdapter implements Runnable, ImageObserver{

  private String[] args = new String[1];
private Image img;
private int width;
private int height;
/**
   * Takes a media container (file) as the first argument, opens it, opens up a
   * Swing window and displays video frames with the right
   * timing.
   * 
   * @param args
   *          Must contain one string which represents a filename
   */
	public String[] setSource(String string){
		System.out.println(string);
		this.args[0] = string;
		return args;
	}
    
	public Image getCurrentImage(){
		return this.img;
	}
	public void onVideoPicture(IVideoPictureEvent event) {
		this.imageUpdate(event.getImage(), 0, 0, event.getImage().getWidth(), event.getImage().getHeight(), 0);
	}
	
  public void run()
  {
    if (args.length <= 0)
      throw new IllegalArgumentException(
          "must pass in a filename as the first argument");

    String filename = args[0];
    
    // create a new reader

    IMediaReader reader = ToolFactory.makeReader(filename);
    
    //
    // Create a MediaViewer object and tell it to play video only
    //
    reader.addListener(this);

    // read out the contents of the media file, and sit back and watch
    
    while (reader.readPacket() == null)
      do {} while(false);
    
    
    
  }

@Override
public synchronized boolean  imageUpdate(Image arg0, int arg1, int arg2, int arg3, int arg4,
		int arg5) {
	this.img = arg0; 
	this.width = arg3;
	this.height = arg4;
	// TODO Auto-generated method stub
	return false;
}





	
	

}
