

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.imageio.ImageIO;

/**
 * Actual game.
 * 
 * @author 
 */

public class Game {
	
	

    /**
     *  which player will have to land.
     *
    private PlayerDrone playerDrone;
    */
    /**
     * Infos from elaboration and connection to rover
     */
    private RoverDriverWithInfos roverDriverWithInfos;
    
    /**
     * Game background image.
     */
    private BufferedImage backgroundImg;
    
    /**
     * Red border of the frame. It is used when player crash the rocket.
     */
    private BufferedImage redBorderImg;
    

    public Game()
    {
        Framework.gameState = Framework.GameState.STREAM_CONTENT_LOADING;
        
        Thread threadForInitGame = new Thread() {
            @Override
            public void run(){
                // Sets variables and objects for the game.
                Initialize();
                // Load game files (images, sounds, ...)
                LoadContent();
                
                Framework.gameState = Framework.GameState.DRIVING;
            }
        };
        threadForInitGame.start();
    }
    
    
    
   /**
     * Set variables and objects for the game.
     */
    private void Initialize()
    {
       // playerDrone = new PlayerDrone();
        roverDriverWithInfos  = new RoverDriverWithInfos();
    }
    
    /**
     * Load game files - images, sounds, ...
     */
    private void LoadContent()
    {
        try
        {
            /*
            URL redBorderImgUrl = this.getClass().getResource("/driver_system/resources/images/red_border.png");
            redBorderImg = ImageIO.read(redBorderImgUrl);*/
            System.out.println("here whe can load extra content");
        }
        catch (Exception ex) {
            Logger.getLogger(Game.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    /**
     * Restart game - reset some variables.
     */
    public void RestartGame()
    {
        this.roverDriverWithInfos.ResetPlayer();
    }
   
    /**
     * Update game logic.
     * 
     * @param gameTime gameTime of the game.
     * @param mousePosition current mouse position.
     */
    public void UpdateGame(long gameTime, Point mousePosition)
    {
        // Move the rocket
        this.roverDriverWithInfos.updatePlayer();
        roverDriverWithInfos.update();
      
        try{
            this.backgroundImg = Framework.video_stream.getCurrentImage();
            
        }catch(NullPointerException e){
            System.err.println("no image found for update game");
        }
        System.out.println("stream: "+roverDriverWithInfos.isStreamConnected());
        System.out.println("router: "+roverDriverWithInfos.motorsWorking());
        // Checks where the player drone is. Is it still connected and moving or is it landed or critical?
        switch(((this.roverDriverWithInfos.isStreamConnected()) ? 1 : 0) + ((roverDriverWithInfos.motorsWorking()) ? 1 : 0)){
            case(1):
                roverDriverWithInfos.critical = true;
                break;
            case(2):
                //running ok
                break;
            case(0):
                roverDriverWithInfos.landed = true;
                break;
                
        }
       
/*          Here we check if the rocket speed isn't too high.
               !!!!!!!!!!!!!!!!!!!! sennò non si resetta il gameTime 
            Framework.gameState = Framework.GameState.GAMEOVER;
        }*/
    }
    
    /**
     * Draw the game to the screen.
     * 
     * @param g2d Graphics2D
     * @param mousePosition current mouse position.
     */
    public void Draw(Graphics2D g2d, Point mousePosition)
    {
        System.out.println("into game Draw");
        g2d.drawImage(backgroundImg, 0, 0, Framework.frameWidth, Framework.frameHeight, null);
        
        roverDriverWithInfos.Draw(g2d);

    }
    
    
    /**
     * Draw the game over screen.
     * 
     * @param g2d Graphics2D
     * @param mousePosition Current mouse position.
     * @param gameTime Game time in nanoseconds.
     */
    public void DrawGameOver(Graphics2D g2d, Point mousePosition, long gameTime)
    {
        Draw(g2d, mousePosition);
        
        g2d.drawString("Press space or enter to restart.", Framework.frameWidth / 2 - 100, Framework.frameHeight / 3 + 70);
        
        if(this.roverDriverWithInfos.landed)
        {
            g2d.drawString("You have successfully landed!", Framework.frameWidth / 2 - 100, Framework.frameHeight / 3);
            g2d.drawString("You have landed after " + gameTime / Framework.secInNanosec + " seconds.", Framework.frameWidth / 2 - 100, Framework.frameHeight / 3 + 20);
        }
        else
        {
            g2d.setColor(Color.red);
            g2d.drawString("You have critical situation!", Framework.frameWidth / 2 - 95, Framework.frameHeight / 3);
            g2d.drawImage(redBorderImg, 0, 0, Framework.frameWidth, Framework.frameHeight, null);
        }
    }
}
