//package driver_system;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class NetworkConnectionToRouter {
    private String hostName;
    private int portNumber;
    private PrintWriter out;
    private Socket echoSocket;
    private int toRouterError =200;
    private BufferedReader stdIn;
    
    public NetworkConnectionToRouter(){
        
        System.out.println("inside NetworkConnectionToRouter");
        try{
             hostName = Framework.DroneHostName;
            portNumber = Framework.DronePortNumber;
        
            System.out.println("NetworkConnectionToRouter sta tentando di connettersi a:"+hostName+portNumber+"");
            echoSocket = new Socket(hostName, portNumber);
            out = new PrintWriter(echoSocket.getOutputStream(), true);
            
             	stdIn = new BufferedReader( new InputStreamReader(echoSocket.getInputStream()));
                    //stdIn =  new BufferedReader(new InputStreamReader(in));
             
        }catch(IOException e){
            this.toRouterError = 404;
            e.printStackTrace();
        }
         
    }
    public int getRouterStatus(){
        return this.toRouterError;
    }
    public String readRemote(){
        try{
            String s = this.stdIn.readLine();
            if(s == null)
                this.toRouterError = 404;
            return s;
            
        }catch(IOException e){
            e.printStackTrace();
            this.toRouterError = 404;
            return "error on reading from socket";
        }
    }
    public void printRemote(String string) {
        // TODO Auto-generated method stub
        
        
        System.out.print("printed on remote socket: "+string+"\n");
        out.println(string);
        
        
    }
    public void disconnect(){
        try {
            out.close();
            echoSocket.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    }
    public boolean isConnected(){
        return (this.toRouterError == 200);
    }
    
}
