//package driver_system;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 
 * 
 * @author
 */

public class RoverDriverWithInfos extends PlayerDrone {
    
	
	public int quote = 0;
    /**
     * X coordinate of the infos area.
     */
    public int x;
    /**
     * Y coordinate of the infos area.
     */
    public int y;
    /*
    * X coordinate of the speed value
    */
    public int x_s;
    /*
     * Y coordinate of the speed value
     */
    public int y_s;
    /*
     * X coordinate of the video stat
     */
    public int x_v;
    /*
     * Y coordinate of the video stat
     */
    public int y_v;
    
    /**
     * infos of video.
     */
    private String infos_video;
    
    
    /**
     * infos of speed.
     */
    private String infos_speed;
    
    /**
     * Width of infos area.
     */
    public int infosAreaImgWidth;
	private BufferedImage infosAreaImg;
    
    
    public RoverDriverWithInfos()
    {
        Initialize();
        LoadContent();
    }
    
    
    private void Initialize()
    {   
        
        x = (int)(Framework.frameWidth * 0.01);
        //  coordinate of the infos area dow on theleft
        y = (int)(Framework.frameHeight * 0.87);
        
        //coordinate of speed values
        x_s = (int)(Framework.frameWidth * 0.50);
        y_s = (int)(Framework.frameHeight * 0.90);
        
        //coordinate of video info's
        x_v = (int)(Framework.frameWidth * 0.85);
        y_v = (int)(Framework.frameHeight * 0.96);
        
        
    }
    
    private void LoadContent()
    {
        try
        {
        	//Framework.video_stream.onlineTime();
            URL landingAreaImgUrl = this.getClass().getResource("/resources/bottom.png");
            infosAreaImg = ImageIO.read(landingAreaImgUrl);
            infosAreaImgWidth = infosAreaImg.getWidth();
            updatePlayer();
        }
        catch (IOException ex) {
            Logger.getLogger(RoverDriverWithInfos.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    public void Draw(Graphics2D g2d)
    {
    	super.Draw(g2d);
    	g2d.drawImage(infosAreaImg,x,y,null);
    	g2d.setColor(Color.white);
        
        g2d.drawString(this.infos_video, x_v, y_v);
        g2d.drawString(this.infos_speed, x_s, y_s);
        
       
    }


	public void update() {
		infos_video = ""+Framework.video_stream.getStatusString()+" for: "+Long.toString(Framework.getTimer())+".";
		infos_speed = " "+this.speedL + "\n"+ this.speedR;
		// TODO Auto-generated method stub

	}


	public boolean isStreamConnected() {
        
         return Framework.video_stream.workingConnection();
		
        
		//return true;
	}


	
    
}
